#include <dlfcn.h>
#include <pthread.h>
#include <stdio.h>

void *
thread_run(void *arg)
{
	void *dlh;
	void (*f)();

	dlh = dlopen("bar/libbar.so", RTLD_LAZY);
	if (dlh == NULL) {
		fprintf(stderr, "dlopen: %s\n", dlerror());
		pthread_exit(0);
	}
	f = dlsym(dlh, "bar");
	if (f == NULL) {
		fprintf(stderr, "dlsym: %s\n", dlerror());
		pthread_exit(0);
	}

	f();

	dlclose(dlh);
	fprintf(stderr, "module closed\n");
	pthread_exit(0);
}

int
main()
{
	pthread_t thr;

	if (pthread_create(&thr, NULL, thread_run, NULL) < 0) {
		perror("pthread_create");
		exit(1);
	}
	pthread_join(thr, NULL);

	return 0;
}
